

//begin ---------------------->
#include "CAec.h"	// has #include "AEC_NTTC.h"
		//PROTOTYPES OF CAec class and the AECPC-TC.DLL FUNCTIONS


#define BIT7	0x80
#define BIT6	0x40
#define BIT5	0x20
#define BIT4	0x10
#define BIT3	0x08
#define BIT2	0x04
#define BIT1	0x02
#define BIT0	0x01
#define NOTBIT7	0x7F
#define NOTBIT6	0xBF
#define NOTBIT5	0xDF
#define NOTBIT4	0xEF
#define NOTBIT3	0xF7
#define NOTBIT2	0xFB
#define NOTBIT1	0xFD
#define NOTBIT0	0xFE



#define SIO_TIMEOUT 2000	//millisecond timeout value 10 is the "standard"

#define READSTR 0
#define READDAT READSTR + 1
#define READUDAT READSTR + 2
#define GENSTR	3
#define GENDAT GENSTR + 1
#define GENUDAT GENSTR + 2
#define	VIDSTR	6
#define	VIDDAT	VIDSTR + 1
#define RBYTESSTR	8
#define RBYTESDAT	RBYTESSTR + 1
#define WBYTESSTR	10
#define WBYTESDAT	WBYTESSTR + 1
#define SCSTR		12
#define SCDAT		SCSTR + 1

#define POLLED_RX		0
#define INTERRUPT_RX	1
#define OPTIONAL_RX		2



struct B2   /* Defines a structure */
{
    BYTE L;	//this order is important!
	BYTE H;   
} ;

union W1B2    // Declare union type
{
	B2	b;
	WORD w;
} ;

//VARIABLE DEFINITIONS
DWORD ReaderDat, GenDat;
char keyId;
volatile int	e_time;
int fieldcnt;
int iTempNum, iSelected;

//AECBrdInfo	AecBoard[3];	// hold data for UP TO three time code boards
							// that are found (if they are installed).
//int		BoardsFound;		// number of boards found in 'find all'
int		boardNum;			// number of boards found in registry
int		aecint;
int		IntIndex, IntCnt1, IntCntBak1;
char	hhmmssff[30], dllinfo[70], misctxt[20];		//data string to hold formated unpacked dataC
char	sCatBufR[50], sCatBufSC[10], sCatBufW[50];
char	charStr[20], rev[2];//character string to hold data sent to screen
//LPCTSTR lpText;

char title_strBase[40] = "Model: ";
char title_str[100] = " ";

//BYTE	rByte1, rByte2, rByte3;
//BYTE	bCom, bRet; // **NEW**
BOOL	returnval, returnval1, ok, bClassRet;
//WORD	Brd1addr, Brd2addr, Brd3addr;
LPSTR	lpPassToAECDLLrev;	// typedef  char FAR*	LPSTR  
DWORD	RetDw, dwOld, dwNew; //, IORdw;
HANDLE	hWinRT2;
//volatile BOOL tc1.exiting = FALSE;
//int min = 999;
//int max = 0;
//int count = 0;
//LARGE_INTEGER last = {0, 0};
//LARGE_INTEGER frequency;

LONG 	xCharAve, yChar; 
RECT	rectB[20];
int		iButton;
char	sBuffer[14];
char	sOffset[3];
BOOL	bR1, bR4, bW1, bW4, bSC, bWrite;
BYTE	BRone, BWone;
DWORD	dRfour, dWfour;
WORD	wOffset;
int		iFieldsTotal;
int		iL21Total;
int 	iFieldsPS;
//float	iFieldsPS;

//Serial Option stuff
//	tmrSIO is the timer to use for 10ms timeout
int		rxIndex, iTimeOutEvents, iRxTimeOutEvents, rx_mode;
BYTE	rxStatByte, iOldRxLen;
char	sAckStr[20], sLtcStr[20], sCtlStr[20], sVitcStr[20], sStatStr[20];
LPSTR	lpRXbuffer;
LPBOOL	lpRxDone, lpRxBusy;
BOOL	bAckBusy, bAckDone, bLtcBusy, bLtcDone, bCtlBusy, bCtlDone;
BOOL	bVitcBusy, bVitcDone, bStatBusy, bStatDone;
BYTE	hh, mm, ss, ff, speed, Nak;
BOOL	bVitcTime, bLtcTime, bCtlTime;
BOOL	bTxPlay, bTxStop, bTxRew, bTxFwd, bTxRec, bTxPause, bTxGoto;
BOOL	bTxVarRew, bTxVarFwd;
BOOL	bTmr10, bTimeOut10, RXready, okRX, TCturn;
W1B2	wRX;
DWORD	dwScratch;
char	sScratch[20];

					
					//FUNCTION PROTOTYPES
DWORD	TcISR1(HANDLE);	//my 1 isr
RECT 	MakeRect(LONG, LONG, LONG);
void	TOut(HDC, RECT, char*);
void	TOutRJ(HDC, RECT, char*);	//Right Justified
BOOL	RxSonyDone(LPSTR, int);		//check to see if string is complete
void	InitSerialVariables();
BOOL	ProcSerial(void);
BOOL	ProcessRXready(HWND, int);
//BOOL	ProcessIntCode(BYTE, HWND);
BOOL	ProcessIntEventCode(BYTE, HWND);
void	ProcessRow(BYTE, int);		//bit field, row of STATUS
void	SetStatus(BYTE, int); 		// bit(set/not set), identifier of control
BOOL	ProcessStatus(void);			// Set all of the STATUS FLAGS as needed
void	MenuUpdate(HMENU);




TEXTMETRIC tm;             /* structure for text metrics    */ 
static DWORD dwCharX;      /* average width of characters   */ 
static DWORD dwCharY;      /* height of characters          */ 
static DWORD dwClientX;    /* width of client area          */ 
static DWORD dwClientY;    /* height of client area         */ 
RECT	rClient;

HWND hwndSIO = NULL;	//handle for SIO option
HWND hwndAecRG1 = NULL;
//HWND hinstSIO;	//for serial option window

// declare Adrienne Electronics classes
CAec tc1;
CTimer tmr1;
CTimer tmrSIO; 
CTimer tmrVid;
CTimer tmrRDRup; 
CTimer tmrGENup; 
CTimer tmrVIDup;
CTimer tmrSioPoll;
CStrHex sh1;
CStrHex shSIO;

//screen/dialog control update compare variables
DWORD cmpRtb, cmpRub, cmpGtb, cmpGub;
BYTE cmpReb, cmpGeb, cmp0C, cmp0D, cmp2E;
BOOL filmAble;



char TCGenRet[100] = " ";
char statusInf[20] = " ";
int m_IntUpdateCount;
// <--------end----------