Attribute VB_Name = "Module4"
Option Explicit

Private Declare Function GdiplusStartup Lib "GDIPlus" ( _
   token As Long, _
   inputbuf As GdiplusStartupInput, _
   Optional ByVal outputbuf As Long = 0) As Long
   
Public Function generateProcess(number As String) As Boolean
    Dim cont, cont2 As Integer
    Dim pictureName As String
    
    Screen.MousePointer = vbHourglass
    Form10.Label1.Caption = ""
    CreateDir (dirpath)
    Form1.ProgressBar1.Visible = True
    Form1.ProgressBar1.Value = 0
    Form1.StatusBar1.Panels(1).text = "Generating Image Files..."
    TempFileName$ = MakeTempFileName("TMP")
    CreateDir (TempFileName)
    
    cont = beginS - 1
    For cont2 = 0 To endS - beginS
        DoEvents
        If cancelProcess Then
            cancelProcess = False
            Form1.ProgressBar1.Value = 0
            Form1.ProgressBar1.Visible = False
            Screen.MousePointer = vbArrow
            Form10.Visible = False
            Form1.StatusBar1.Panels(1).text = "Generation Canceled"
            Form1.btnCancel.Visible = False
            Form1.exportButton.Visible = True
            Exit Function
        End If
        generateImages subtitles(cont), cont + 1
        Form1.ProgressBar1.Value = (cont2 / (endS - beginS)) * 100
        cont = cont + 1
        
    Next

    numImageView = beginS - 1
    
    If ImageType = 0 Then
        pictureName = makeName(numImageView, "bmp", fillWithZeros)
        Form10.Label1.Caption = nameNumPic & numImageView & ".bmp"
    ElseIf ImageType = 1 Then
        pictureName = makeName(numImageView, "tif", fillWithZeros)
        Form10.Label1.Caption = nameNumPic & numImageView & ".tif"
    End If
    
    Form1.ProgressBar1.Visible = False
    Form1.StatusBar1.Panels(1).text = CStr(endS - numImageView) & " Image Files Generated, Nav File Generated"
    If ImageType <> 2 Then
        Form10.PicTiff.Picture = Form10.LoadPicturePlus(pictureName)
    
        Form10.PicTiff.Scale (0, 0)-(Form10.PicTiff.Width / TWIPSPERPIXEL, Form10.PicTiff.Height / TWIPSPERPIXEL)
        Form10.PicTiff.PaintPicture Form10.PicTiff.Picture, 0, 0, Form10.PicTiff.Width / TWIPSPERPIXEL, Form10.PicTiff.Height / TWIPSPERPIXEL
    
        Form10.Text2.text = subtitles(numImageView).TCin
        Form10.Text3.text = subtitles(numImageView).TCout
        Form10.endPic.Enabled = True
        Form10.startPic.Enabled = True
        Form10.prevPic.Enabled = True
        Form10.nextPic.Enabled = True
    End If
    Form2.printScript
    Screen.MousePointer = vbArrow
    Form1.exportButton.Visible = True
    Form1.btnCancel.Visible = False
End Function

Public Function generateImages(subt As subtitle, number As Integer)
    Dim ret, res As Long
    Dim booleano As Boolean
    Dim color, color2, color3 As Long
    Dim edge, ta As Integer
    Dim pictureName As String
    
    Form1.Refresh
    Form1.AutoRedraw = True
    Form10.Refresh
    Form10.AutoRedraw = True
    Set Form1.gdip = New cGdiPlus
    
    Form6.Picture = LoadPicture(App.path & "\Images\source" & Form6.Width / TWIPSPERPIXEL & Form6.Height / TWIPSPERPIXEL & ".bmp")
    
    With screenpos(subt.positionV + 1)
        If Pal = "NTSC" Then
            Form6.CurrentY = TWIPSPERPIXEL * .Y_NTSC
        ElseIf Pal = "PAL" Then
            Form6.CurrentY = TWIPSPERPIXEL * .Y_PAL
        ElseIf Pal = "HDTV" Then
            Form6.CurrentY = TWIPSPERPIXEL * .Y_HDTV
        End If
        If subt.line2 <> "" Then
            borders subt.Line1 & Chr(10) & subt.line2, Form6.CurrentX, Form6.CurrentY / TWIPSPERPIXEL, subt.positionH
        Else
            borders subt.Line1, Form6.CurrentX, Form6.CurrentY / TWIPSPERPIXEL, subt.positionH
        End If
    End With
    
    
    Set Form6.Picture = Form6.image
    pictureName = makeName(subt.positionIn, "bmp", fillWithZeros)
    Call SavePicture(Form6.Picture, pictureName)
    Form1.picDisplay.Picture = LoadPicture(pictureName)
    
    If Form2.Clip.Value = 1 Then
        Form1.Picture1.Height = heigthText
        Form1.Picture1.Width = widthText
    Else
        Form1.Picture1.Height = heightpic
        Form1.Picture1.Width = widthpic
    End If
    
    
    Form1.Picture1.AutoRedraw = True
    Set Form1.picDisplay.Picture = Form1.picDisplay.image
    If Form2.Clip.Value = 1 Then
        Form1.Picture1.PaintPicture Form1.picDisplay.Picture, 0, 0, widthText * TWIPSPERPIXEL, heigthText * TWIPSPERPIXEL, 0, 0, widthText * TWIPSPERPIXEL, heigthText * TWIPSPERPIXEL
    Else
        Form1.Picture1.PaintPicture Form1.picDisplay.Picture, 0, 0, widthpic * TWIPSPERPIXEL, heightpic * TWIPSPERPIXEL, 0, 0, widthpic * TWIPSPERPIXEL, heightpic * TWIPSPERPIXEL
    End If
    Form1.Picture1.Picture = Form1.Picture1.image
    
    Kill pictureName
    
    Call SavePicture(Form1.Picture1, pictureName)
    If ImageType = 1 Then
        Select Case numImageView
            Case Is < 10:
                nameNumPic = namepic & "000"
            Case Is < 100:
                nameNumPic = namepic & "00"
            Case Is < 1000:
                nameNumPic = namepic & "0"
            Case Is < 10000:
                nameNumPic = namepic
        End Select
    
        FileCopy pictureName, TempFileName & nameNumPic & numImageView & ".bmp"
        Kill pictureName
        pictureName = makeName(subt.positionIn, "tif", fillWithZeros)
        If Not Form1.gdip.PictureBoxToFile(Form1.Picture1, dirpath & "\" & nameNumPic & subt.positionIn & ".tif") Then
            Err.Raise vbObjectError, , "Can't open the image."
        End If
    ElseIf ImageType = 2 Then
        Dim lResult As Long
        Dim nIndex As Long
        Dim crColor As Long
        Dim nSkipTop As Long
        
        pictureName = makeName(subt.positionIn, "bmp", fillWithZeros)
        On Error Resume Next
        Err.Clear
        nIndex = 0
        crColor = RGB(&HC0, &HC0, &HC0)
        nSkipTop = 0
        lResult = Bmp2UycX(pictureName, vbNullString, nIndex, crColor, nSkipTop)
        
        If Err.number Then
            MsgBox "Error " & Hex(Err.number) & "  " & Err.Source & Chr(13) & Err.Description
            Exit Function
        End If
    
        If lResult Then
            MsgBox "Conversion Error " & lResult
            Exit Function
        End If
        Kill pictureName

    End If

    Form1.picDisplay.Refresh
    Form1.Picture1.Refresh
    Form6.Picture = Nothing
    Form1.Picture1.Picture = Nothing
    Form1.picDisplay.Picture = Nothing
    Form1.Picture1 = Nothing
    Form1.picDisplay = Nothing
    Set Form1.gdip = Nothing
    Form1.Picture1 = LoadPicture()
    Form1.picDisplay = LoadPicture()
End Function



Public Function borders(TextPreview As String, x As Integer, Y As Integer, posHorizontal As String)
    Dim textUnicode     As String
    Dim Rectangle       As RECTF
    Dim colors(1)       As Long
    Dim aligment        As Integer
    Dim anti            As Boolean
    
    Form6.Cls
    textUnicode = toUnicode(TextPreview)

    If Form2.Clip.Value = 1 Then
        'rectangle.Top = 0
        'widthText = Len(textUnicode) * sizeFont * 1.5
        'If InStr(1, TextPreview, Chr(13)) > 0 Then
        '    heigthText = sizeFont * 2 * 2
        'Else
        '    heigthText = sizeFont * 2
        'End If
        Rectangle.top = Y
        widthText = Form6.ScaleWidth
        heigthText = Form6.ScaleHeight

    Else
        Rectangle.top = Y
        widthText = Form6.ScaleWidth
        heigthText = Form6.ScaleHeight
    End If
    
    Rectangle.bottom = heigthText
    Rectangle.left = 0
    Rectangle.right = widthText

    
    colors(0) = GetRGB_VB2GDIP(Form8.CommonDialog1.color)
    colors(1) = GetRGB_VB2GDIP(Form8.CommonDialog2.color)
            
    If posHorizontal = " " Then
        aligment = StringAlignmentCenter
    ElseIf posHorizontal = "L" Then
        aligment = StringAlignmentNear
    ElseIf posHorizontal = "R" Then
        aligment = StringAlignmentFar
    End If
    
    If Form8.Antialising.Value = 1 Then
        anti = True
    Else
        anti = False
    End If
    
    paintText Form6.hdc, Rectangle, textUnicode, anti, aligment, colors, 0
End Function



Public Sub paintText(ByVal lhDC As Long, ByRef rct As RECTF, ByVal sText As String, ByVal AntiAliased As Boolean, ByVal Alignment As Integer, ByRef colors() As Long, ByVal LocaleID As Long)

    Dim FS              As Long
    Dim box             As RECTF
    Dim pen             As Long
    Dim path            As Long
    Dim brush           As Long
    Dim curFont         As Long
    Dim fontfam         As Long
    Dim graphics        As Long
    Dim strFormat       As Long
    Dim isAvailable     As Long
    Dim borderCount     As Long


   Dim rcLayout As RECTF   ' Designates the string drawing bounds
   Dim rcOrigin As RECTF   ' Only the Left/X and Top/Y members are used; rest should be zero
   
   rcOrigin.left = 0
   rcOrigin.top = 0



    GdipCreateFromHDC lhDC, graphics   ' Initialize the graphics class - required for all drawing
    If AntiAliased Then
        GdipSetSmoothingMode graphics, SmoothingModeHighQuality  'SmoothingModeAntiAlias
    Else
        GdipSetSmoothingMode graphics, SmoothingModeDefault
    End If
    GdipSetTextRenderingHint graphics, TextRenderingHintAntiAliasGridFit 'TextRenderingHint
    GdipCreateFontFamilyFromName nameFont, 0, fontfam
    GdipIsStyleAvailable fontfam, FS, isAvailable
    If isAvailable = 0 Then
        Dim msg              As String
        msg = "Font family " & nameFont & " NOT available under GDI+"
        MsgBox msg
        Exit Sub
    End If
    FS = 0
    If Not styleFont = "Normal" Then FS = FS + 1

    GdipCreateFont fontfam, sizeFont * 1.5, FS, UnitPoint, curFont
    GdipCreateStringFormat 0, LocaleID, strFormat
    

    GdipSetStringFormatAlign strFormat, Alignment
    GdipGetStringFormatTrimming strFormat, StringTrimmingEllipsisPath
    GdipCreatePath FillModeWinding, path
    GdipMeasureString graphics, sText, -1, curFont, rcOrigin, 0, rcLayout, 0, 0
    
    widthText = rcLayout.right
    rcLayout.bottom = rcLayout.bottom * 0.75
    heigthText = rcLayout.bottom
    
    If Form2.Clip = 1 Then
        GdipAddPathString path, sText, -1, fontfam, FS, sizeFont * 1.5, rcLayout, strFormat
        LSet box = rcLayout
    Else
        GdipAddPathString path, sText, -1, fontfam, FS, sizeFont * 1.5, rct, strFormat
        LSet box = rct
    End If
    
    GdipCreateSolidFill colors(1), brush
    
    If brush Then
        GdipFillPath graphics, brush, path
        GdipDeleteBrush brush
    End If
    
    If sizeEdge > 0 Then
        GdipCreatePen1 colors(0), sizeEdge, UnitPixel, pen
        If pen Then
            GdipDrawPath graphics, pen, path
            GdipDeletePen pen
        End If
    End If
    ' Cleanup
    GdipDeleteStringFormat strFormat
    GdipDeleteFont curFont
    GdipDeleteFontFamily fontfam
    GdipDeletePath path
    GdipDeleteGraphics graphics
End Sub


